Index: /pjproject/branches/projects/aps-direct/pjproject.dsw
===================================================================
--- /pjproject/branches/projects/aps-direct/pjproject.dsw	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjproject.dsw	(revision 2468)
@@ -234,4 +234,7 @@
     Project_Dep_Name pjnath
     End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjmedia_audiodev
+    End Project Dependency
 }}}
 
@@ -363,4 +366,7 @@
     Project_Dep_Name libsrtp
     End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjmedia_audiodev
+    End Project Dependency
 }}}
 
@@ -451,4 +457,61 @@
     End Project Dependency
     Begin Project Dependency
+    Project_Dep_Name libgsmcodec
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name libilbccodec
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name libportaudio
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name libresample
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name libspeex
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjnath
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name libsrtp
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjmedia_audiodev
+    End Project Dependency
+}}}
+
+###############################################################################
+
+Project: "samples"=".\pjsip-apps\build\samples.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+    Begin Project Dependency
+    Project_Dep_Name pjlib
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjlib_util
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjmedia
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjmedia_codec
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjsip_core
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjsip_simple
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjsip_ua
+    End Project Dependency
+    Begin Project Dependency
     Project_Dep_Name pjsua_lib
     End Project Dependency
@@ -481,5 +544,5 @@
 ###############################################################################
 
-Project: "samples"=".\pjsip-apps\build\samples.dsp" - Package Owner=<4>
+Project: "test_pjsip"=".\pjsip\build\test_pjsip.dsp" - Package Owner=<4>
 
 Package=<5>
@@ -513,61 +576,4 @@
     Project_Dep_Name pjsua_lib
     End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name libgsmcodec
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name libilbccodec
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name libportaudio
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name libresample
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name libspeex
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjnath
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name libsrtp
-    End Project Dependency
-}}}
-
-###############################################################################
-
-Project: "test_pjsip"=".\pjsip\build\test_pjsip.dsp" - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-    Begin Project Dependency
-    Project_Dep_Name pjlib
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjlib_util
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjmedia
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjmedia_codec
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjsip_core
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjsip_simple
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjsip_ua
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjsua_lib
-    End Project Dependency
 }}}
 
Index: /pjproject/branches/projects/aps-direct/pjsip-apps/build/Samples-vc.mak
===================================================================
--- /pjproject/branches/projects/aps-direct/pjsip-apps/build/Samples-vc.mak	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjsip-apps/build/Samples-vc.mak	(revision 2468)
@@ -14,4 +14,5 @@
 PJMEDIA_LIB = ..\..\pjmedia\lib\pjmedia-$(TARGET)$(LIBEXT)
 PJMEDIA_CODEC_LIB = ..\..\pjmedia\lib\pjmedia-codec-$(TARGET)$(LIBEXT)
+PJMEDIA_AUDIODEV_LIB = ..\..\pjmedia\lib\pjmedia-audiodev-$(TARGET)$(LIBEXT)
 PJSIP_LIB = ..\..\pjsip\lib\pjsip-core-$(TARGET)$(LIBEXT)
 PJSIP_UA_LIB = ..\..\pjsip\lib\pjsip-ua-$(TARGET)$(LIBEXT)
@@ -30,6 +31,6 @@
 
 LIBS = $(PJSUA_LIB_LIB) $(PJSIP_UA_LIB) $(PJSIP_SIMPLE_LIB) \
-	  $(PJSIP_LIB) $(PJMEDIA_CODEC_LIB) $(PJMEDIA_LIB) $(PJNATH_LIB) \
-	  $(PJLIB_UTIL_LIB) $(PJLIB_LIB) \
+	  $(PJSIP_LIB) $(PJMEDIA_CODEC_LIB) $(PJMEDIA_AUDIODEV_LIB) \
+	  $(PJMEDIA_LIB) $(PJNATH_LIB) $(PJLIB_UTIL_LIB) $(PJLIB_LIB) \
 	  $(THIRD_PARTY_LIBS)
 
@@ -50,5 +51,6 @@
 
 
-SAMPLES = $(BINDIR)\confsample.exe \
+SAMPLES = $(BINDIR)\auddemo.exe \
+	  $(BINDIR)\confsample.exe \
 	  $(BINDIR)\confbench.exe \
 	  $(BINDIR)\encdec.exe \
@@ -66,6 +68,4 @@
 	  $(BINDIR)\siprtp.exe \
 	  $(BINDIR)\sipstateless.exe \
-	  $(BINDIR)\sndinfo.exe \
-	  $(BINDIR)\sndtest.exe \
 	  $(BINDIR)\stateful_proxy.exe \
 	  $(BINDIR)\stateless_proxy.exe \
Index: /pjproject/branches/projects/aps-direct/pjsip-apps/build/Samples.mak
===================================================================
--- /pjproject/branches/projects/aps-direct/pjsip-apps/build/Samples.mak	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjsip-apps/build/Samples.mak	(revision 2468)
@@ -14,5 +14,6 @@
 BINDIR := ../bin/samples
 
-SAMPLES := confsample \
+SAMPLES := auddemo \
+	   confsample \
 	   encdec \
 	   latency \
@@ -29,6 +30,4 @@
 	   siprtp \
 	   sipstateless \
-	   sndinfo \
-	   sndtest \
 	   stateful_proxy \
 	   stateless_proxy \
Index: /pjproject/branches/projects/aps-direct/pjsip-apps/src/pjsua/pjsua_app.c
===================================================================
--- /pjproject/branches/projects/aps-direct/pjsip-apps/src/pjsua/pjsua_app.c	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjsip-apps/src/pjsua/pjsua_app.c	(revision 2468)
@@ -4060,4 +4060,10 @@
     app_config.cfg.cb.on_nat_detect = &on_nat_detect;
 
+    /* Set sound device latency */
+    if (app_config.capture_lat > 0)
+	app_config.media_cfg.snd_rec_latency = app_config.capture_lat;
+    if (app_config.playback_lat)
+	app_config.media_cfg.snd_play_latency = app_config.playback_lat;
+
     /* Initialize pjsua */
     status = pjsua_init(&app_config.cfg, &app_config.log_cfg,
@@ -4318,7 +4324,4 @@
     if (status != PJ_SUCCESS)
 	goto on_error;
-
-    /* Set sound device latency */
-    pjmedia_snd_set_latency(app_config.capture_lat, app_config.playback_lat);
 
     /* Use null sound device? */
Index: /pjproject/branches/projects/aps-direct/pjsip-apps/src/samples/auddemo.c
===================================================================
--- /pjproject/branches/projects/aps-direct/pjsip-apps/src/samples/auddemo.c	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjsip-apps/src/samples/auddemo.c	(revision 2468)
@@ -30,5 +30,4 @@
 
 static unsigned dev_count;
-static pjmedia_aud_dev_id dev_id[MAX_DEVICES];
 
 static void app_perror(const char *title, pj_status_t status)
@@ -54,10 +53,8 @@
     PJ_LOG(3,(THIS_FILE, "Found %d devices:", dev_count));
 
-    dev_count = pjmedia_aud_dev_enum(PJ_ARRAY_SIZE(dev_id), dev_id);
-
     for (i=0; i<dev_count; ++i) {
 	pjmedia_aud_dev_info info;
 
-	status = pjmedia_aud_dev_get_info(dev_id[i], &info);
+	status = pjmedia_aud_dev_get_info(i, &info);
 	if (status != PJ_SUCCESS)
 	    continue;
@@ -71,61 +68,16 @@
 {
     static char text[200];
+    unsigned i;
 
     text[0] = '\0';
 
-    if (caps & PJMEDIA_AUD_DEV_CAP_EXT_FORMAT) {
-	strcat(text, "extfmt ");
-    }
-
-    if (caps & PJMEDIA_AUD_DEV_CAP_INPUT_LATENCY) {
-	strcat(text, "inlatency ");
-    }
-
-    if (caps & PJMEDIA_AUD_DEV_CAP_OUTPUT_LATENCY) {
-	strcat(text, "outlatency ");
-    }
-
-    if (caps & PJMEDIA_AUD_DEV_CAP_INPUT_VOLUME_SETTING) {
-	strcat(text, "invol ");
-    }
-
-    if (caps & PJMEDIA_AUD_DEV_CAP_OUTPUT_VOLUME_SETTING) {
-	strcat(text, "outvol ");
-    }
-
-    if (caps & PJMEDIA_AUD_DEV_CAP_INPUT_SIGNAL_VOLUME) {
-	strcat(text, "insignal ");
-    }
-
-    if (caps & PJMEDIA_AUD_DEV_CAP_OUTPUT_SIGNAL_VOLUME) {
-	strcat(text, "outsignal ");
-    }
-
-    if (caps & PJMEDIA_AUD_DEV_CAP_INPUT_ROUTE) {
-	strcat(text, "inroute ");
-    }
-
-    if (caps & PJMEDIA_AUD_DEV_CAP_OUTPUT_ROUTE) {
-	strcat(text, "outroute ");
-    }
-
-    if (caps & PJMEDIA_AUD_DEV_CAP_EC) {
-	strcat(text, "ec ");
-    }
-
-    if (caps & PJMEDIA_AUD_DEV_CAP_EC_TAIL) {
-	strcat(text, "ectail ");
-    }
-
-    if (caps & PJMEDIA_AUD_DEV_CAP_VAD) {
-	strcat(text, "vad ");
-    }
-
-    if (caps & PJMEDIA_AUD_DEV_CAP_CNG) {
-	strcat(text, "cng ");
-    }
-
-    if (caps & PJMEDIA_AUD_DEV_CAP_PLC) {
-	strcat(text, "plc ");
+    for (i=0; i<31; ++i) {
+	if ((1 << i) & caps) {
+	    const char *capname;
+	    capname = pjmedia_aud_dev_cap_name((pjmedia_aud_dev_cap)(1 << i), 
+					       NULL);
+	    strcat(text, capname);
+	    strcat(text, " ");
+	}
     }
 
@@ -145,5 +97,5 @@
     }
 
-    status = pjmedia_aud_dev_get_info(dev_id[index], &info);
+    status = pjmedia_aud_dev_get_info(index, &info);
     if (status != PJ_SUCCESS) {
 	app_perror("pjmedia_aud_dev_get_info() error", status);
@@ -154,5 +106,5 @@
     PJ_LOG(3, (THIS_FILE, "-------------------------"));
 
-    PJ_LOG(3, (THIS_FILE, H": %u (0x%x)", "ID", dev_id[index], dev_id[index]));
+    PJ_LOG(3, (THIS_FILE, H": %u (0x%x)", "ID", index, index));
     PJ_LOG(3, (THIS_FILE, H": %s", "Name", info.name));
     PJ_LOG(3, (THIS_FILE, H": %s", "Driver", info.driver));
@@ -205,12 +157,12 @@
 			unsigned chnum)
 {
-    pjmedia_aud_dev_param param;
+    pjmedia_aud_param param;
     pjmedia_aud_test_results result;
     pj_status_t status;
 
     if (dir & PJMEDIA_DIR_CAPTURE) {
-	status = pjmedia_aud_dev_default_param(dev_id[rec_id], &param);
+	status = pjmedia_aud_dev_default_param(rec_id, &param);
     } else {
-	status = pjmedia_aud_dev_default_param(dev_id[play_id], &param);
+	status = pjmedia_aud_dev_default_param(play_id, &param);
     }
 
@@ -221,6 +173,6 @@
 
     param.dir = dir;
-    param.rec_id = dev_id[rec_id];
-    param.play_id = dev_id[play_id];
+    param.rec_id = rec_id;
+    param.play_id = play_id;
     param.clock_rate = clock_rate;
     param.channel_count = chnum;
@@ -286,5 +238,5 @@
     pj_pool_t *pool = NULL;
     pjmedia_port *wav = NULL;
-    pjmedia_aud_dev_param param;
+    pjmedia_aud_param param;
     pjmedia_aud_stream *strm = NULL;
     char line[10];
@@ -304,5 +256,5 @@
     }
 
-    status = pjmedia_aud_dev_default_param(dev_id[rec_index], &param);
+    status = pjmedia_aud_dev_default_param(rec_index, &param);
     if (status != PJ_SUCCESS) {
 	app_perror("pjmedia_aud_dev_default_param()", status);
@@ -354,5 +306,5 @@
     pj_pool_t *pool = NULL;
     pjmedia_port *wav = NULL;
-    pjmedia_aud_dev_param param;
+    pjmedia_aud_param param;
     pjmedia_aud_stream *strm = NULL;
     char line[10];
@@ -371,5 +323,5 @@
     }
 
-    status = pjmedia_aud_dev_default_param(dev_id[play_index], &param);
+    status = pjmedia_aud_dev_default_param(play_index, &param);
     if (status != PJ_SUCCESS) {
 	app_perror("pjmedia_aud_dev_default_param()", status);
Index: /pjproject/branches/projects/aps-direct/pjsip/include/pjsua-lib/pjsua.h
===================================================================
--- /pjproject/branches/projects/aps-direct/pjsip/include/pjsua-lib/pjsua.h	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjsip/include/pjsua-lib/pjsua.h	(revision 2468)
@@ -4201,4 +4201,18 @@
     unsigned		ec_tail_len;
 
+    /**
+     * Audio capture buffer length, in milliseconds.
+     *
+     * Default: PJMEDIA_SND_DEFAULT_REC_LATENCY
+     */
+    unsigned		snd_rec_latency;
+
+    /**
+     * Audio playback buffer length, in milliseconds.
+     *
+     * Default: PJMEDIA_SND_DEFAULT_PLAY_LATENCY
+     */
+    unsigned		snd_play_latency;
+
     /** 
      * Jitter buffer initial prefetch delay in msec. The value must be
@@ -4805,7 +4819,11 @@
  *
  */
+#if PJMEDIA_AUDIO_API==PJMEDIA_AUDIO_API_NEW_ONLY
+PJ_DECL(pj_status_t) pjsua_enum_snd_devs(pjmedia_aud_dev_info info[],
+					 unsigned *count);
+#else
 PJ_DECL(pj_status_t) pjsua_enum_snd_devs(pjmedia_snd_dev_info info[],
 					 unsigned *count);
-
+#endif
 
 
@@ -4880,5 +4898,18 @@
 
 /**
- * Configure the echo canceller tail length of the sound port.
+ * Change the echo cancellation settings. The behavior of this function 
+ * depends on whether the sound device is currently active, and if it is,
+ * whether device or software AEC is being used. 
+ *
+ * If the sound device is currently active, and if the device supports AEC,
+ * this function will forward the change request to the device and it will
+ * be up to the device on whether support the request. If software AEC is
+ * being used (the software EC will be used if the device does not support
+ * AEC), this function will change the software EC settings. In all cases,
+ * the setting will be saved for future opening of the sound device.
+ *
+ * If the sound device is not currently active, this will only change the
+ * default AEC settings and the setting will be applied next time the 
+ * sound device is opened.
  *
  * @param tail_ms	The tail length, in miliseconds. Set to zero to
@@ -4911,14 +4942,4 @@
  */
 PJ_DECL(pj_status_t) pjsua_get_ec_tail(unsigned *p_tail_ms);
-
-
-/**
- * Set sound device route.
- *
- * @param route		Sound device route to be set.
- *
- * @return		PJ_SUCCESS on success, or the appropriate error code.
- */
-PJ_DECL(pj_status_t) pjsua_set_snd_route(pjmedia_snd_route route);
 
 
Index: /pjproject/branches/projects/aps-direct/pjsip/src/pjsua-lib/pjsua_core.c
===================================================================
--- /pjproject/branches/projects/aps-direct/pjsip/src/pjsua-lib/pjsua_core.c	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjsip/src/pjsua-lib/pjsua_core.c	(revision 2468)
@@ -178,4 +178,6 @@
     cfg->ilbc_mode = PJSUA_DEFAULT_ILBC_MODE;
     cfg->ec_tail_len = PJSUA_DEFAULT_EC_TAIL_LEN;
+    cfg->snd_rec_latency = PJMEDIA_SND_DEFAULT_REC_LATENCY;
+    cfg->snd_play_latency = PJMEDIA_SND_DEFAULT_PLAY_LATENCY;
     cfg->jb_init = cfg->jb_min_pre = cfg->jb_max_pre = cfg->jb_max = -1;
     cfg->snd_auto_close_time = -1;
Index: /pjproject/branches/projects/aps-direct/pjsip/src/pjsua-lib/pjsua_media.c
===================================================================
--- /pjproject/branches/projects/aps-direct/pjsip/src/pjsua-lib/pjsua_media.c	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjsip/src/pjsua-lib/pjsua_media.c	(revision 2468)
@@ -1515,18 +1515,13 @@
  * Open sound device with extended setting.
  */
-static pj_status_t open_snd_dev_ext( int capture_dev,
-				     int playback_dev,
-				     unsigned clock_rate,
-				     unsigned channel_count,
-				     unsigned samples_per_frame,
-				     const pjmedia_snd_setting *setting)
+static pj_status_t open_snd_dev_ext(pjmedia_aud_param *param)
 {
     pjmedia_port *conf_port;
     pj_status_t status;
 
-    PJ_ASSERT_RETURN(setting, PJ_EINVAL);
+    PJ_ASSERT_RETURN(param, PJ_EINVAL);
 
     /* Check if NULL sound device is used */
-    if (NULL_SND_DEV_ID == capture_dev || NULL_SND_DEV_ID == playback_dev) {
+    if (NULL_SND_DEV_ID==param->rec_id || NULL_SND_DEV_ID==param->play_id) {
 	return pjsua_set_null_snd_dev();
     }
@@ -1545,24 +1540,17 @@
 
     PJ_LOG(4,(THIS_FILE, "Opening sound device @%d/%d/%s",
-	      clock_rate, channel_count,
-	      (setting->format.id==PJMEDIA_FORMAT_L16?"raw":"encoded")));
+	      param->clock_rate, param->channel_count,
+	      (param->ext_fmt.id==PJMEDIA_FORMAT_L16?"pcm":"encoded")));
 
     status = pjmedia_snd_port_create2( pjsua_var.snd_pool, 
-				       PJMEDIA_DIR_CAPTURE_PLAYBACK,
-				       capture_dev,
-				       playback_dev, 
-				       clock_rate, 
-				       channel_count,
-				       samples_per_frame,
-				       16, 
-				       setting, 
-				       &pjsua_var.snd_port);
+				       param,  &pjsua_var.snd_port);
 
     /* Update port 0 info when sound dev opened successfully. */
     if (status == PJ_SUCCESS) {
-	conf_port->info.format = setting->format;
-	conf_port->info.clock_rate = clock_rate;
-	conf_port->info.samples_per_frame = samples_per_frame;
-	conf_port->info.channel_count = channel_count;
+	pj_memcpy(&conf_port->info.format, &param->ext_fmt, 
+		  sizeof(conf_port->info.format));
+	conf_port->info.clock_rate = param->clock_rate;
+	conf_port->info.samples_per_frame = param->samples_per_frame;
+	conf_port->info.channel_count = param->channel_count;
 	conf_port->info.bits_per_sample = 16;
     } else {
@@ -1583,21 +1571,21 @@
 
     /* Save the device IDs */
-    pjsua_var.cap_dev = capture_dev;
-    pjsua_var.play_dev = playback_dev;
+    pjsua_var.cap_dev = param->rec_id;
+    pjsua_var.play_dev = param->play_id;
 
     /* Update sound device name. */
-    do {
-	const pjmedia_snd_dev_info *play_info;
-	pjmedia_snd_stream *strm;
-	pjmedia_snd_stream_info si;
+    {
+	pjmedia_aud_dev_info play_info;
+	pjmedia_aud_stream *strm;
+	pjmedia_aud_param si;
         pj_str_t tmp;
 
 	strm = pjmedia_snd_port_get_snd_stream(pjsua_var.snd_port);
-	pjmedia_snd_stream_get_info(strm, &si);
-	play_info = pjmedia_snd_get_dev_info(si.rec_id);
-
-	pjmedia_conf_set_port0_name(pjsua_var.mconf, 
-				    pj_cstr(&tmp, play_info->name));
-    } while(0);
+	pjmedia_aud_stream_get_param(strm, &si);
+	if (pjmedia_aud_dev_get_info(si.play_id, &play_info)==PJ_SUCCESS) {
+	    pjmedia_conf_set_port0_name(pjsua_var.mconf, 
+					pj_cstr(&tmp, play_info.name));
+	}
+    };
 
     return PJ_SUCCESS;
@@ -1612,12 +1600,15 @@
     /* Close sound device */
     if (pjsua_var.snd_port) {
-	pjmedia_snd_dev_info cap_info, play_info;
-	pjmedia_snd_stream *strm;
-	pjmedia_snd_stream_info si;
+	pjmedia_aud_dev_info cap_info, play_info;
+	pjmedia_aud_stream *strm;
+	pjmedia_aud_param param;
 
 	strm = pjmedia_snd_port_get_snd_stream(pjsua_var.snd_port);
-	pjmedia_snd_stream_get_info(strm, &si);
-	cap_info = *(pjmedia_snd_get_dev_info(si.rec_id));
-	play_info = *(pjmedia_snd_get_dev_info(si.play_id));
+	pjmedia_aud_stream_get_param(strm, &param);
+
+	if (pjmedia_aud_dev_get_info(param.rec_id, &cap_info) != PJ_SUCCESS)
+	    cap_info.name[0] = '\0';
+	if (pjmedia_aud_dev_get_info(param.play_id, &play_info) != PJ_SUCCESS)
+	    play_info.name[0] = '\0';
 
 	PJ_LOG(4,(THIS_FILE, "Closing %s sound playback device and "
@@ -1797,16 +1788,41 @@
 
 	if (need_reopen) {
-	    pjmedia_snd_setting setting;
-
-	    pj_bzero(&setting, sizeof(setting));
-	    setting.format = peer_info.format;
-	    setting.plc = PJ_FALSE;
-	    setting.route = PJMEDIA_SND_ROUTE_DEFAULT;
+	    pjmedia_aud_param param;
+
+	    status = pjmedia_aud_dev_default_param(pjsua_var.cap_dev, &param);
+	    if (status != PJ_SUCCESS) {
+		pjsua_perror(THIS_FILE, "Error retrieving default audio "
+					"device parameters", status);
+		return status;
+	    }
+
+	    param.dir = PJMEDIA_DIR_CAPTURE_PLAYBACK;
+	    param.rec_id = pjsua_var.cap_dev;
+	    param.play_id = pjsua_var.play_dev;
+	    param.clock_rate = peer_info.clock_rate;
+	    param.samples_per_frame = peer_info.samples_per_frame;
+	    param.channel_count = peer_info.channel_count;
+	    param.bits_per_sample = peer_info.bits_per_sample;
+	    /* Latency setting */
+	    param.flags |= (PJMEDIA_AUD_DEV_CAP_INPUT_LATENCY | 
+			    PJMEDIA_AUD_DEV_CAP_OUTPUT_LATENCY);
+	    param.input_latency_ms = pjsua_var.media_cfg.snd_rec_latency;
+	    param.output_latency_ms = pjsua_var.media_cfg.snd_play_latency;
+	    /* EC settings */
+	    if (pjsua_var.media_cfg.ec_tail_len) {
+		param.flags |= (PJMEDIA_AUD_DEV_CAP_EC | PJMEDIA_AUD_DEV_CAP_EC_TAIL);
+		param.ec_enabled = PJ_TRUE;
+		param.ec_tail_ms = pjsua_var.media_cfg.ec_tail_len;
+	    } else {
+		param.flags &= ~(PJMEDIA_AUD_DEV_CAP_EC | PJMEDIA_AUD_DEV_CAP_EC_TAIL);
+	    }
+	    /* Format */
+	    param.flags |= (PJMEDIA_AUD_DEV_CAP_EXT_FORMAT | 
+			    PJMEDIA_AUD_DEV_CAP_OUTPUT_ROUTE);
+	    param.ext_fmt = peer_info.format;
+	    //param.plc = PJ_FALSE;
+	    param.out_route = PJMEDIA_AUD_DEV_ROUTE_DEFAULT;
 	    
-	    status = open_snd_dev_ext(pjsua_var.cap_dev, pjsua_var.play_dev,
-				      peer_info.clock_rate,
-				      peer_info.channel_count,
-				      peer_info.samples_per_frame,
-				      &setting);
+	    status = open_snd_dev_ext(&param);
 	    if (status != PJ_SUCCESS) {
 		pjsua_perror(THIS_FILE, "Error opening sound device", status);
@@ -2307,4 +2323,27 @@
  * Enum sound devices.
  */
+#if PJMEDIA_AUDIO_API==PJMEDIA_AUDIO_API_NEW_ONLY
+PJ_DEF(pj_status_t) pjsua_enum_snd_devs( pjmedia_aud_dev_info info[],
+					 unsigned *count)
+{
+    unsigned i, dev_count;
+
+    dev_count = pjmedia_aud_dev_count();
+    
+    if (dev_count > *count) dev_count = *count;
+
+    for (i=0; i<dev_count; ++i) {
+	pj_status_t status;
+
+	status = pjmedia_aud_dev_get_info(i, &info[i]);
+	if (status != PJ_SUCCESS)
+	    return status;
+    }
+
+    *count = dev_count;
+
+    return PJ_SUCCESS;
+}
+#else	/* PJMEDIA_AUDIO_API */
 PJ_DEF(pj_status_t) pjsua_enum_snd_devs( pjmedia_snd_dev_info info[],
 					 unsigned *count)
@@ -2312,13 +2351,22 @@
     unsigned i, dev_count;
 
-    dev_count = pjmedia_snd_get_dev_count();
+    dev_count = pjmedia_aud_dev_count();
     
     if (dev_count > *count) dev_count = *count;
+    pj_bzero(info, dev_count * sizeof(pjmedia_snd_dev_info));
 
     for (i=0; i<dev_count; ++i) {
-	const pjmedia_snd_dev_info *ci;
-
-	ci = pjmedia_snd_get_dev_info(i);
-	pj_memcpy(&info[i], ci, sizeof(*ci));
+	pjmedia_aud_dev_info ai;
+	pj_status_t status;
+
+	status = pjmedia_aud_dev_get_info(i, &ai);
+	if (status != PJ_SUCCESS)
+	    return status;
+
+	strncpy(info[i].name, ai.name, sizeof(info[i].name));
+	info[i].name[sizeof(info[i].name)-1] = '\0';
+	info[i].input_count = ai.input_count;
+	info[i].output_count = ai.output_count;
+	info[i].default_samples_per_sec = ai.default_samples_per_sec;
     }
 
@@ -2327,4 +2375,7 @@
     return PJ_SUCCESS;
 }
+#endif
+
+
 /*
  * Select or change sound device. Application may call this function at
@@ -2335,10 +2386,10 @@
 {
     pjmedia_port *conf_port;
-    const pjmedia_snd_dev_info *play_info;
+    pjmedia_aud_dev_info play_info;
+    pjmedia_aud_param param;
     unsigned clock_rates[] = {0, 44100, 48000, 32000, 16000, 8000};
     unsigned selected_clock_rate = 0;
     unsigned i;
-    pjmedia_snd_stream *strm;
-    pjmedia_snd_stream_info si;
+    pjmedia_aud_stream *strm;
     pj_str_t tmp;
     pj_status_t status = -1;
@@ -2353,5 +2404,5 @@
 
     /* Create memory pool for sound device. */
-    pjsua_var.snd_pool = pjsua_pool_create("pjsua_snd", 4000, 4000);
+    pjsua_var.snd_pool = pjsua_pool_create("pjsua_snd", 1000, 1000);
     PJ_ASSERT_RETURN(pjsua_var.snd_pool, PJ_ENOMEM);
 
@@ -2365,8 +2416,30 @@
     pj_assert(conf_port != NULL);
 
+    /* Create default parameters for the device */
+    status = pjmedia_aud_dev_default_param(capture_dev, &param);
+    if (status != PJ_SUCCESS) {
+	return status;
+    }
+    param.dir = PJMEDIA_DIR_CAPTURE_PLAYBACK;
+    param.rec_id = capture_dev;
+    param.play_id = playback_dev;
+    param.channel_count = pjsua_var.media_cfg.channel_count;
+    /* Latency settings */
+    param.flags |= (PJMEDIA_AUD_DEV_CAP_INPUT_LATENCY | 
+		    PJMEDIA_AUD_DEV_CAP_OUTPUT_LATENCY);
+    param.input_latency_ms = pjsua_var.media_cfg.snd_rec_latency;
+    param.output_latency_ms = pjsua_var.media_cfg.snd_play_latency;
+    /* EC settings */
+    if (pjsua_var.media_cfg.ec_tail_len) {
+	param.flags |= (PJMEDIA_AUD_DEV_CAP_EC | PJMEDIA_AUD_DEV_CAP_EC_TAIL);
+	param.ec_enabled = PJ_TRUE;
+	param.ec_tail_ms = pjsua_var.media_cfg.ec_tail_len;
+    } else {
+	param.flags &= ~(PJMEDIA_AUD_DEV_CAP_EC | PJMEDIA_AUD_DEV_CAP_EC_TAIL);
+    }
+
     /* Attempts to open the sound device with different clock rates */
     for (i=0; i<PJ_ARRAY_SIZE(clock_rates); ++i) {
 	char errmsg[PJ_ERR_MSG_SIZE];
-	unsigned samples_per_frame;
 
 	PJ_LOG(4,(THIS_FILE, 
@@ -2374,15 +2447,12 @@
 		  "@%d Hz", clock_rates[i]));
 
-	samples_per_frame = clock_rates[i] *
-			    pjsua_var.media_cfg.audio_frame_ptime *
-			    pjsua_var.media_cfg.channel_count / 1000;
+	param.clock_rate = clock_rates[i];
+	param.samples_per_frame = clock_rates[i] *
+				  pjsua_var.media_cfg.audio_frame_ptime *
+				  pjsua_var.media_cfg.channel_count / 1000;
 
 	/* Create the sound device. Sound port will start immediately. */
-	status = pjmedia_snd_port_create(pjsua_var.snd_pool, capture_dev,
-					 playback_dev, 
-					 clock_rates[i], 
-					 pjsua_var.media_cfg.channel_count,
-					 samples_per_frame,
-					 16, 0, &pjsua_var.snd_port);
+	status = pjmedia_snd_port_create2(pjsua_var.snd_pool, &param,
+					  &pjsua_var.snd_port);
 
 	if (status == PJ_SUCCESS) {
@@ -2438,9 +2508,4 @@
     }
 
-    /* Set AEC */
-    pjmedia_snd_port_set_ec( pjsua_var.snd_port, pjsua_var.snd_pool, 
-			     pjsua_var.media_cfg.ec_tail_len, 
-			     pjsua_var.media_cfg.ec_options);
-
     /* Connect sound port to the bridge */ 	 
     status = pjmedia_snd_port_connect(pjsua_var.snd_port, 	 
@@ -2460,18 +2525,18 @@
     /* Update sound device name. */
     strm = pjmedia_snd_port_get_snd_stream(pjsua_var.snd_port);
-    pjmedia_snd_stream_get_info(strm, &si);
-    play_info = pjmedia_snd_get_dev_info(si.rec_id);
-
-    if (si.clock_rate != pjsua_var.media_cfg.clock_rate) {
+    pjmedia_aud_stream_get_param(strm, &param);
+    pjmedia_aud_dev_get_info(param.play_id, &play_info);
+
+    if (param.clock_rate != pjsua_var.media_cfg.clock_rate) {
 	char tmp_buf[128];
 	int tmp_buf_len = sizeof(tmp_buf);
 
 	tmp_buf_len = pj_ansi_snprintf(tmp_buf, sizeof(tmp_buf)-1, "%s (%dKHz)",
-				       play_info->name, si.clock_rate/1000);
+				       play_info.name, param.clock_rate/1000);
 	pj_strset(&tmp, tmp_buf, tmp_buf_len);
         pjmedia_conf_set_port0_name(pjsua_var.mconf, &tmp); 
     } else {
         pjmedia_conf_set_port0_name(pjsua_var.mconf, 
-				    pj_cstr(&tmp, play_info->name));
+				    pj_cstr(&tmp, play_info.name));
     }
 
@@ -2580,27 +2645,4 @@
 }
 
-/* 
- * Header for specific Symbian APS audio routing.
- */
-#include <pjmedia/symbian_sound_aps.h>
-
-/*
- * Set sound device route.
- */
-PJ_DEF(pj_status_t) pjsua_set_snd_route(pjmedia_snd_route route)
-{
-#if PJMEDIA_SOUND_IMPLEMENTATION == PJMEDIA_SOUND_SYMB_APS_SOUND
-    pjmedia_snd_stream *strm;
-
-    if (!pjsua_var.snd_port)
-	return PJ_ENOTFOUND;
-
-    strm = pjmedia_snd_port_get_snd_stream(pjsua_var.snd_port);
-    return pjmedia_snd_aps_set_route(strm, route);
-#else
-    PJ_UNUSED_ARG(route);
-    return PJ_ENOTSUP;
-#endif
-}
 
 /*****************************************************************************
